/*   FILE NAME : EXAMP3.C                                          */
/*   Program Example : VOLTAGE MEASUREMENT WITH DVM                */
/*                                                                 */
/*   Purpose : This program measures 10 voltage readings           */
/*             and displays them.                                  */
/*                                                                 */
/*   Remark : This program is written for the HP3478A DMM. If      */
/*            an other model of voltmeter is used, please check    */
/*            the operating manual and make necessary modifi-      */
/*            cation to this program.                              */
/*                                                                 */
/*   Language : C86                                                */
/*                                                                 */
#include <stdio.h>
#include <math.h>
extern double atof();

int ioerr;

main()
{

  char *dvmstr,instr[100];
  unsigned i;

  crt_cls();
  ieseg(0xC000);
  ieabort();

  /*  Set the DVM  */
  dvmstr="F1T3RAN3";
  ioerr=ieoutput(23,dvmstr,8);
  iochk();

  /*  Measurement start   */

  for(i=1;i<60001;i++)
  {
     ietrig(23);                 /*   Trigger the DVM.   */
     ioerr=ieenter(23,instr,100);      /*   Enter DVM reading  */
     iochk();                    /*   Error check        */
     if(instr[0]=='+')instr[0]=32;  /* C86 can't accept '+' */
     printf("\n  %7d   %4.6f VOLTS",i,atof(instr));
  }
}

iochk()  /*  I/O error check routine  */
{
  switch(ioerr){
    case 0 : break;
    case 1 : printf("\nTIME OUT !!");exit(0);
    default : printf("\nINTERFACE ERROR !!");exit(0);
  }
}

