/*   FILE NAME : EXAMP5.C                                        */
/*   Program Example : MULTIPLE DEVICE TRIGGERING                */
/*                                                               */
/*   Purpose : This program triggers 2 voltmeters at the same    */
/*          time to make the measurement simultaneously.         */
/*                                                               */
/*   Remark : This program is written for the HP3478A DMM. If    */
/*         an other model of voltmeter is used, please check     */
/*         the operating manual and make necessary modifi-       */
/*         cation to this program.                               */
/*                                                               */
/*   Language : C86                                              */
/*                                                               */
#include <stdio.h>
int ioerr;

main(){
  char *cmdstr,instr1[100],instr2[100];
  int i,dvm1,dvm2;
  dvm1=23; dvm2=24;
  crt_cls();
  ieseg(0xC000);
  ieabort();

  /*  Set the DVM's   */
  cmdstr="F1T3RAN5";
  ioerr=ieoutput(dvm1,cmdstr,8);   /* Send DVM #1 setting string */
  iochk();                         /* Error check                */
  ioerr=ieoutput(dvm2,cmdstr,8);   /* Send DVM #2 setting string */
  iochk();                         /* Error check                */

  /* Measurement start  */
  cmdstr="UNL UNT MTA LISTEN 23 24 GET";
  for(i=1;i<11;i++){
    iesend(cmdstr,strlen(cmdstr));  /* Trigger the DVM's.         */
    ioerr=ieenter(dvm1,instr1,100); /* Enter DVM #1 reading       */
    iochk();                        /* Error check                */
    ioerr=ieenter(dvm2,instr2,100); /* Enter DVM #2 reading       */
    iochk();                        /* Error check                */
    printf("\n%3d   V1= %s      V2= %s",i,instr1,instr2);
  }
}

iochk()  /*  I/O error check routine  */
{
  switch(ioerr){
    case 0 : break;
    case 1 : printf("\nTIME OUT !!");exit(0);
    default : printf("\nINTERFACE ERROR !!");exit(0);
  }
}

