{ FILE NAME : EX1_MS.PAS                                            }
{             INTERACTIVE DATA TRANSFER                             }
{ Purpose   : This program outputs data strings entered by users    }
{             and enters data string from the IEEE-488 bus.         }
{ Language  : Microsoft Pascal                                      }

program example1(input,output);

{$INCLUDE : 'MSPGPIB.INC'}

procedure iochk;
  var
    errno [ origin 16#C000:16#201A] : integer;

  begin
    writeln;
    case errno of
      0 : writeln(' Data transferred!');
      1 : writeln(' Handshake timeout ! ');
      otherwise
          writeln(' Interface Error ! ');
    end;
    writeln;
  end;

procedure outputdata;
  var
    addr,length : integer;
    outstr      : lstring(255);
    s           : char;

  begin
    repeat
      writeln;
      writeln(' OUTPUT DATA :');
      write(' To which address ? ');
      readln(addr); writeln;
      write(' Output string ? ');
      readln(outstr);
      writeln(' Outputing data ...');
      ieoutput(addr,outstr);
      iochk;
      write(' Output data again ?(y/n)  ');
      readln(s); writeln;
    until s='n';
  end;

procedure enterdata;
  var
    addr,length : integer;
    instr       : lstring(255);
    s           : char;

  begin
    repeat
      writeln(' ENTER DATA :');
      write(' From which address ? ');
      readln(addr); writeln;
      writeln(' Entering string ... ');
      ieenter(addr,instr);
      iochk;
      writeln(' Entered string : ',instr);
      write(' Enter data again ?(y/n)  ');
      readln(s); writeln;
    until s='n';
  end;

var
  sel,i  :   integer;

begin
  ieseg(16#C000);
  ietimout(30000);
  repeat
    ieabort;
    for i:=1 to 24 do writeln;       { clear screen   }

    writeln('*** Demo Program for GP-IB Interface *** ');
    writeln;
    writeln(' 1 : OUTPUT DATA');
    writeln;
    writeln(' 2 : ENTER DATA');
    writeln;
    writeln(' 3 : EXIT');
    writeln;
    write(' Select a function : ');
    readln(sel); writeln;
    if (sel<4) and (sel>0) then
      begin
        case sel of
          1 : outputdata;
          2 : enterdata;
          3 : ;
          otherwise
              writeln('********** SOMETHING WRONG ! ************');
        end;
      end;
  until sel=3;
end.

{     END OF PROGRAM   }
