{ FILE NAME : EX3_MS.PAS				      }
{	      VOLTAGE MEASUREMENT WITH DVM		      }
{ Purpose   : This program measures 10 voltage readings       }
{	      and displays them.			      }
{ Remark    : This program is written for the HP3478A DMM. If }
{	      another model of voltmeter is used, please check}
{	      the operating manual and make necessary modifi- }
{	      cation to this program.			      }
{ Language  : Microsoft Pascal				      }

Program example3(input,output);

{$INCLUDE : 'MSPGPIB.INC'}

Procedure iochk;  {  I/O error check routine  }
  var
    errno [ origin 16#C000:16#201A] : integer;

  begin
    case errno of
      0 : ;
      1 : writeln('TIME OUT !!');
      otherwise
       writeln('INTERFACE ERROR !!');
    end;
  end;

var
  dvmstr,instr	: lstring(80);
  i,addr,code	: integer;
  v		: real;
  dumflag	: boolean;
begin
  ieseg(16#C000);
  for i:=1 to 24 do writeln;
  ieabort;
  addr:=23;
  writeln(' Voltage Measurement :');
  {  Set the DVM  }
  dvmstr:='F1T3RAN5';
  ieoutput(addr,dvmstr);
  iochk;

  {  Measurement start	 }

  for i:=1 to 10 do
    begin
      ietrig(addr);		      {   Trigger the DVM.   }
      ieenter(addr,instr);	      {   Enter DVM reading  }
      iochk;			      {   Error check	     }
      if instr[1]='+' then delete(instr,1,1);
      dumflag:=decode(instr,v);
      writeln('  ',i:4,'    ',v:4:7,' VOLTS');
    end;
end.
{ End of Program }
