{
5-3   Voltage Measurement with DVM

}

{ FILE NAME : EX3_TB.PAS                                      }
{             VOLTAGE MEASUREMENT WITH DVM                    }
{ Purpose   : This program measures 10 voltage readings       }
{             and displays them.                              }
{ Remark    : This program is written for the HP3478A DMM. If }
{             another model of voltmeter is used, please check}
{             the operating manual and make necessary modifi- }
{             cation to this program.                         }
{ Language  : Turbo Pascal                                    }

Program example3(input,output);

{$I TBPGPIB.INC}

Procedure iochk;  {  I/O error check routine  }
  var
    errno : integer absolute $C000:$201A;

  begin
    case errno of
      0 : ;
      1 : writeln('TIME OUT !!');
      else
       writeln('INTERFACE ERROR !!');
    end;
  end;

var
  dvmstr,instr  : lstring;
  i,addr,code   : integer;
  v             : real;

begin
  clrscr;
  ieabort;
  addr:=23;
  writeln(' Voltage Measurement :');
  {  Set the DVM  }
  dvmstr:='F1T3RAN5';
  ieoutput(addr,dvmstr);
  iochk;

  {  Measurement start   }

  for i:=1 to 10 do
    begin
      ietrig(addr);                   {   Trigger the DVM.   }
      instr:='                                ';
      ieenter(addr,instr);            {   Enter DVM reading  }
      iochk;                          {   Error check        }
      if instr[1]='+' then delete(instr,1,1);
      val(instr,v,code);
      writeln('  ',i:4,'    ',v:4:7,' VOLTS');
    end;
end.
{ End of Program }
