{ FILE NAME : EX5_MS.PAS				      }
{	      MULTIPLE DEVICE TRIGGERING		      }
{ Purpose   : This program triggers 2 voltmeters at the same  }
{	      time to make the measurement simultaneously.    }
{ Remark    : This program is written for the HP3478A DMM. If }
{	      another model of voltmeter is used, please check}
{	      the operating manual and make necessary modifi- }
{	      cation to this program.			      }
{ Language  : Microsoft Pascal				      }

Program example5(input,output);

{$INCLUDE : 'MSPGPIB.INC'}

procedure iochk;		 {  I/O error check routine  }
var
  errno [origin 16#C000:16#201A] : integer;

begin
  case errno of
    0 : ;
    1 : writeln('TIME OUT !!');
    otherwise
	writeln('INTERFACE ERROR !!');
  end;
end;				 { End of iochk 	 }

var
  cmdstr,instr1,instr2 : lstring(100);
  i,dvm1,dvm2	       : integer;

begin				 { Begin of main	 }
  ieseg(16#C000);
  ieabort;

  for i:=1 to 24 do writeln;	 { Clear Screen 	 }

  dvm1:=23;
  dvm2:=24;

  {  Set the DVM's   }
  cmdstr:='F1T3RAN5';
  ieoutput(dvm1,cmdstr);	 { Send DVM #1 setting string }
  iochk;			 { Error check		      }
  ieoutput(dvm2,cmdstr);	 { Send DVM #2 setting string }
  iochk;			 { Error check		      }

  { Measurement start }
  cmdstr:='UNL UNT MTA LISTEN 23 24 GET';
  for i:=1 to 10 do
  begin
    iesend(cmdstr);		 { Trigger the DVM's.         }
    ieenter(dvm1,instr1);	 { Enter DVM #1 reading       }
    iochk;			 { Error check		      }
    ieenter(dvm2,instr2);	 { Enter DVM #2 reading       }
    iochk;
    writeln(i:4,' V1 : ',instr1,'    V2 : ',instr2);
  end;
end.				 { End of Program	      }

