'*************************************************************************
' FILE NAME:    QB1A34.BAS                                               *
'                                                                        *
'               4834 DATA LOOP BACK TEST                                 *
'                                                                        *
' DATE:         8/9/89                                                   *
' AUTHOR:       KATHY PU                                                 *
' REMARK:       Refer to the readme.doc file for more details            *
'                                                                        *
' LIBRARY FILE: PC1ALIB.QLB If run from inside the environment           *
'               PC1ALIB.LIB If run from the DOS command line             *
'                                                                        *
' INCLUDE FILE: PC1ACOM.BAS                                              *
'               If the path of include file is different from C:\QB45,   *
'               the code related w/the include file also needs change.   *
'*************************************************************************


' $INCLUDE: 'C:\QB45\PC1ACOM.BAS'

SETTING% = &H100              'select basic compiler
T% = 32000                    'set time out period
PCONFIG% = 8                  'response a 1 on line 0 for 4834 ready
'***************************************************************************
' call EOL to set up string terminators for the PC1A, therefore PC1A can
' communicate with the 4834
'
'OUTEOL% = 2  PC1A's output string terminated w/outeols only and not w/eoi
'OUTEOL$ =     CR and LF as the output string terminator to mark the end
'INEOL%  = 0  terminated when ineolb received or EOI true or input string full
'INEOLBYTE    the char upon which the input string will be terminated
'***************************************************************************

OUTEOL% = 2: INEOL% = 0
INEOLBYTE% = 13

CLS
DEF SEG = &HD000              'set segment address for firmware machine code
CALL ABSOLUTE(IOPORT%, MYADDR%, SETTING%, INIT%)
CALL ABSOLUTE(T%, TIMEOUT%)
LOCATE 1, 1
PRINT "REV. 3.0  8/9/89"
LOCATE 2, 25
PRINT ">>> DEMO PC1A DATA LOOP BACK TEST <<<"
LOCATE 4, 1
INPUT "ENTER 4834 DEVICE ADDRESS. USE ADDRESS OTHER THAN 0 OR 21:"; ADDR%
CALL ABSOLUTE(ABORT%)
CALL ABSOLUTE(ADDR%, DEVCLR%) 'clear the 4834 buffer
CALL ABSOLUTE(ADDR%, PCONFIG%, PPOLLC%)
CALL ABSOLUTE(ADDR%, OUTEOL%, OUTEOL$, INEOL%, INEOLBYTE%, EOL%)
CALL SETUP4834("T1", ADDR%)
LOCATE 6, 1
PRINT "Display default 4834 configuratin as follows: "
LOCATE 7, 1
CALL READ4834SETUP(ADDR%)    'read and display 4834 default configuration
LOCATE 8, 1
INPUT "Use default? You need 'T1' for loop test. Enter y/n: "; USEDEFAULT$
'***************************************************************************
' If not to use default configuration, then
' loop for change of configuration until configuration ok
'***************************************************************************

IF CHR$(NKEY) = UCASE$(USEDEFAULT$) THEN   'if not to use default
        CONFIGOK$ = "N"
        DO WHILE CONFIGOK$ = "N"           'loop for configuration change
           LOCATE 10, 1                    'until config. ok
           INPUT "Enter configuration: "; CONFIG$
           CALL SETUP4834(CONFIG$, ADDR%)
           LOCATE 12, 1
           PRINT "Display 4834 configuration as: "
           LOCATE 13, 1
           CALL READ4834SETUP(ADDR%)
           LOCATE 15, 1
           INPUT "Is configuration OK? Y/N: "; CONFIGOK$
           CONFIGOK$ = UCASE$(CONFIGOK$)
           FOR I% = 9 TO 15
            LOCATE I%, 1
            PRINT SPACE80S
           NEXT I%
        LOOP
END IF
'**************************************************************************
' looping for data loop back test, output to 4834 and then input from 4834
' until user want to quit
'**************************************************************************
CONTINUE$ = "Y"
DO WHILE CONTINUE$ <> "N"
        LOCATE 12, 1
        INPUT "Enter a test string to be sent to 4834 : "; OUTPUT$
                                  'input a data string to be sent to the 4834
        CALL ABSOLUTE(ADDR%, OUTPUT$, IOOUTPUT%)  'send the string to 4834
        LOCATE 14, 1
        PRINT "Serial poll result is DIO line 8 be a 0 when in local loop mode. "
        LOCATE 15, 1
        INPUT "Serial poll? y/n: "; DOSPOLL$
        DOSPOLL$ = UCASE$(DOSPOLL$)
        IF DOSPOLL$ <> "N" THEN                   'if want to do serial poll
                CALL ABSOLUTE(ADDR%, R%, SPOLL%)  'do a serial poll
                S$ = HEX$(R%)
                LOCATE 16, 1
                PRINT "4834 Serial poll response byte in hex = "; S$
        END IF

        '---prepare for an enter from 4834
        CALL SETPTALKADD(ADDR%)                   'make 4834 a talker
        DATAS = SPACE100S                         'blank the data string
        CALL ABSOLUTE(-1, DATAS, ENTER%)          'input from the bus
        LOCATE 17, 1
        PRINT "Display data input from 4834: ", DATAS

        '---parallel poll response should always be a 0 if in local loop mode
        LOCATE 19, 1
        PRINT "Result of parallel poll should be DIO line 0 be 0 if in local loop"
        LOCATE 20, 1
        INPUT "Parallel poll ? y/n: ", DOPPOLL$    'ask if want to paral. poll
        DOPPOLL$ = UCASE$(DOPPOLL$)
        IF DOPPOLL$ <> "N" THEN                    'if want to do parallel poll
                CALL ABSOLUTE(R%, PPOLL%)          'do a parallel poll
                P$ = HEX$(R%)
                LOCATE 22, 1
                PRINT "parallel poll response byte in hex = "; P$
        END IF
        '---test whether to continue the test
        LOCATE 23, 1
        INPUT "Continue the loop back test? y/n"; CONTINUE$
        CONTINUE$ = UCASE$(CONTINUE$)
        IF CONTINUE$ = "Y" THEN                    'if continue the loop test
          FOR I% = 11 TO 23
                LOCATE I%, 1
                PRINT SPACE80S
          NEXT I%
        END IF
LOOP
END

