'**************************************************************************
'FILE NAME:      QB1ADEV.BAS
'                This demo program makes the PC1A card function as
'                a device that sends out and receives data from the
'                bus controller.
'
'DATE:           8/9/89
'AUTHOR:         KATHY PU
'
'LIBRARY FILE:   PC1ALIB.QLB If run from inside the environment
'                PC1ALIB.LIB If run from the DOS command line
'
'INCLUDE FILE:   PC1ACOM.BAS
'                If the path of include file is different from C:\QB45,
'                the code related w/the include file also needs change.
'
'REMARK:         REFER TO THE README.DOC FOR MORE DETAILS
'**************************************************************************

'       $INCLUDE: 'C:\QB45\PC1ACOM.BAS'

'**************************************************************************
' output string terminator is CR LF, input string terminator is LF
' OUTEOL=0 means terminated w/OUTEOL$ only
' INEOL=0  means terminated when ineolb rcvd or EOI true
'**************************************************************************
DIM RINGBUFFER(1 TO 4)  AS STRING

STATUS% = 42: REG% = 9     'IEEE status command address and status number

OUTEOL$ = CHR$(13) + CHR$(10)
OUTEOL% = 2: INEOL% = 0: INEOLBYTE% = 10
BUFFERHEAD% = 0: BUFFERTAIL% = 0
TA% = 0: LA% = 0: READCOUNT% = 0: WRITECOUNT% = 0: LASTBUFFERNO% = 4
SETTING = &H120            'select device and basic compiler


CLS
LOCATE 1, 1:    PRINT "rev 3.0 8/9/89"
LOCATE 2, 25:   PRINT ">>>DEMO PC1A AS A DEVICE<<<"
LOCATE 4, 1:    PRINT "After you enter the PC1A's device address, "
LOCATE 5, 1:    PRINT "If need keyboard input, press RETURN. If want to exit, press ESC"
LOCATE 6, 1
INPUT "Enter device address for pc1a.  Use address other than 0 or 21 : "; MYADDR%

'initialize pc1a as a device, normal speed,no interrupt, and basic compiler
DEF SEG = &HD000
CALL ABSOLUTE(IOPORT%, MYADDR%, SETTING%, INIT%)
CALL ABSOLUTE(IOERR%, IOCOUNT%, ERRPTR%)
CALL ABSOLUTE(0, TIMEOUT%) 'disable timeout,
                           'and wait until operation is done
CALL ABSOLUTE(MYADDR%, OUTEOL%, OUTEOL$, INEOL%, INEOLBYTE%, EOL%)
KEYHIT$ = ""

'*********************************************************************
'*    FOREVER LOOP that check
'*    1. if PC1A has been addressed as a talker
'*    2. or has been addressed as a listener
'*    3. or if RTN is pressed and
'*       has not been addressed as a talker
'*    UNTIL ESC KEY IS PRESSED
'*********************************************************************
DO WHILE (KEYHIT$ <> CHR$(ESCKEY))
        KEYHIT$ = ""
        ADDRSTATUS% = INP(IOPORT% + 4)
        IF (ADDRSTATUS% = 0) THEN
            OUT IOPORT% + 4, &H31  'RESET ADD MODE REGISTER
        END IF                     'SO THAT BUS TALK OR LISTEN DIRECTION
                                   'IS RIGHT

'***********************************************
'  TEST THE ADDRESS STATUS REGISER OF 7210
'***********************************************
        IF (ADDRSTATUS% = 20) THEN 'test if LPAS LA both are 1
            LA% = 1
            TA% = 0

          ELSEIF (ADDRSTATUS% = 10) THEN 'test if TPAS TA both are 1
            TA% = 1
            LA% = 0
          ELSE
            TA% = 0
            LA% = 0
        END IF
'********************************************************************
'Check if the 1st condition happened - if addressed as a listener
'********************************************************************
   IF LA% = 1 THEN
          IOCOUNT% = 0
          FOR I% = 8 TO 17
            LOCATE I%, 1: PRINT SPACE80S
          NEXT I%

          'loop entering data until data be entered from controller

          IOCOUNT% = 0
          DO WHILE (IOCOUNT% = 0)
              DATAS = SPACE100S
              CALL ABSOLUTE(-1, DATAS, ENTER%)
              CALL ABSOLUTE(REG%, IOCOUNT%, STATUS%)
          LOOP

          LOCATE 8, 1: PRINT "display string read from controller as :"
          LOCATE 9, 1: PRINT DATAS
   END IF

'*******************************************************************
'check if the 2nd condition happened  - if addressed as a talker
'*******************************************************************
   IF TA% = 1 THEN                          ' if addressed as talker
                READCOUNT% = READCOUNT + 1
                FOR I% = 8 TO 17
                    LOCATE I%, 1: PRINT SPACE80S
                NEXT I%
          IF (READCOUNT% <= WRITECOUNT%) THEN 'if readcount% <=writecount%
                                              'means buffer is not empty
                                              'advance head and output to bus
                BUFFERHEAD% = BUFFERHEAD% + 1
                IF (BUFFERHEAD% > LASTBUFFERNO%) THEN
                    BUFFERHEAD% = 1           'wrap around the ring buffer
                END IF
                TEMP$ = RINGBUFFER(BUFFERHEAD%)
                CALL ABSOLUTE(-1, TEMP$, IOOUTPUT%)
          ELSE                                 ' if readcount% > writecount%
                                               'means buffer is run out of, empty
                                               'input from keyboard to ringbuffer
                                               'advance buffer write count
                                               'advance buffer head, buffer tail
                                               'wrap around if > 4
                BUFFERHEAD% = BUFFERHEAD% + 1
                IF (BUFFERHEAD% > LASTBUFFERNO%) THEN
                BUFFERHEAD% = 1
                END IF
                BUFFERTAIL% = BUFFERTAIL% + 1
                IF (BUFFERTAIL% > LASTBUFFERNO%) THEN
                BUFFERTAIL% = 1
                END IF

                WRITECOUNT% = WRITECOUNT% + 1
                LOCATE 11, 1
                PRINT "You are addressed as a talker, but you have no data in buffer."
                LOCATE 12, 1
                INPUT "Enter data: "; RINGBUFFER(BUFFERTAIL%)
                TEMP$ = RINGBUFFER(BUFFERTAIL%)
                CALL ABSOLUTE(-1, TEMP$, IOOUTPUT%)
         END IF

         LOCATE 14, 1: PRINT "Send data in ringbuffer to bus as: "
         LOCATE 15, 1: PRINT RINGBUFFER(BUFFERHEAD%)
         LOCATE 16, 1
         PRINT "read count that counts strings read from buffer and output to bus = "; READCOUNT%
         LOCATE 17, 1
         PRINT "write count that counts strings entered fm keyboard and put to buffer= "; WRITECOUNT%

   END IF              'the 2nd if - if addressed as a talker
'**********************************************************************
'the 3rd if - if neither addressed as a listener, nor as a talker
'**********************************************************************
   KEYHIT$ = INKEY$        'check if key hit
   IF (KEYHIT$ = CHR$(RTNKEY)) THEN
                           'if keyhit and not buffer full, then promp for input
     IF (NOT ((BUFFERTAIL% = BUFFERHEAD%) AND (WRITECOUNT% > READCOUNT%))) THEN
        WRITECOUNT% = WRITECOUNT + 1
        BUFFERTAIL% = BUFFERTAIL% + 1  ' DO INPUT FROM KEYBOARD
        IF (BUFFERTAIL% > LASTBUFFERNO%) THEN
        BUFFERTAIL% = 1
        END IF
        LOCATE 20, 1
        INPUT "Enter keyboard input to ring buffer: "; RINGBUFFER(BUFFERTAIL%)
        LOCATE 20, 1: PRINT SPACE80S
     END IF

     ' if keyhit and not addressed as a talker, generate SRQ

     IF (TA% = 0) THEN
     OUT IOPORT% + 3, &H41
     END IF
   END IF                    'the 3rd if

  LOOP       'forever loop while  ESCKEY  is not pressed
  END

