'****************************************************************************
'FILE NAME:        QB1AINT.BAS                                              *
'                                                                            *
'                  Demo how a 4834 uses the SRQ to interrupt the PC.        *
'                  It uses interrupt vector 0x0f for IRQ7. The vector is    *
'                  redirected to point to the new interrupt service routine *
'                  - QB45ISR.                                               *
'                                                                           *
'DATE:             8/9/89                                                   *
'AUTHOR:           KATHY   PU                                               *
'                                                                           *
'LIBRARY FILE:     INT1A.LIB  for program run at the DOS command line       *
'                  INT1A.QLB  for program run from inside the environment   *
'INCLUDE FILE:     PC1ACOM.BAS                                              *
'                  If the path of include file is different from C:\QB45,   *
'                  the code related w/the include file also needs change.   *
'REMARK:           Refer to the readme.doc for more details                 *
'****************************************************************************
' $INCLUDE: 'C:\QB45\PC1ACOM.BAS'

  IRQ% = 7:     ISRDONE = 0: INTCOUNT = 0
'**************************************************************************
'  set parameter value for EOL, therefore PC1A can communicate w/4834
'
'  OUTEOL = 2  terminated w/outeols only and not w/eoi
'  OUTEOL$ =   CR  and LF as the output string terminator
'  INEOL = 0   termnated when ineolb rcvd or EOI true or input string full
'  INEOLBYTE   the char upon which the input string will be terminated
'**************************************************************************

OUTEOL = 2:   INEOL = 0: INEOLBYTE = 13: OUTEOL$ = CHR$(13) + CHR$(10)

SETTING = &H31C          'ENABLE SRQ, COMPILED BASIC, SELECT IRQ7
T% = 32000
CLS :          DEF SEG = &HD000

CALL ABSOLUTE(IOPORT%, MYADDR%, SETTING%, INIT%)
CALL ABSOLUTE(T%, TIMEOUT%)
CALL ABSOLUTE(ABORT%)

CALL CHGVECTOR(IRQ%)      'change the interrupt vector for the required irq

LOCATE 1, 1: PRINT "rev. 3.0 8/9/89"
LOCATE 2, 25: PRINT ">>>DEMO PC1A INTERRUPT FUNCTION<<<"
LOCATE 4, 1
INPUT "Enter 4834 device adress. Use address other than 0 or 21: "; ADDR%
CALL ABSOLUTE(ADDR%, OUTEOL%, OUTEOL$, INEOL%, INEOLBYTE%, EOL%)
CALL SETUP4834("T1 A0", ADDR%)
LOCATE 6, 1: PRINT "Display default 4834 configuration as follows: "
LOCATE 7, 1: CALL READ4834SETUP(ADDR%)

LOCATE 8, 1: PRINT "Always keep 'T1 A0' for this loop back interrupt test. "
LOCATE 9, 1: INPUT "Use default, y/n? "; usedefault$
usedefault$ = UCASE$(usedefault$)

'*********************************************************************
'LOOP FOR CHANGE OF CONFIGURATION INPUT until configuration ok
'*********************************************************************

IF usedefault$ = "N" THEN
    configok$ = "N"

    DO WHILE configok$ = "N"
        FOR I% = 6 TO 11
           LOCATE I%, 1
           PRINT SPACE80S
        NEXT I%
        LOCATE 6, 1
        PRINT "You need to have 'T1 A0' in your configuration. "
        LOCATE 7, 1
        INPUT "Enter configuration "; CONFIG$
        CALL SETUP4834(CONFIG$, ADDR%)
        LOCATE 8, 1: PRINT "Current 4834 configuration is : "
        LOCATE 9, 1: CALL READ4834SETUP(ADDR%)
        LOCATE 11, 1: INPUT "Is configuration ok? y/n "; configok$
    LOOP
        LOCATE 6, 1:  PRINT SPACE80S
        LOCATE 11, 1: PRINT SPACE80S

END IF
'****************************************************************************
'LOOP FOR 4834 DATA LOOP BACK TEST BEGINS HERE
'IT ENDS WHEN USER WANT TO QUIT
'****************************************************************************

   continue$ = "Y"
   CALL ABSOLUTE(ADDR%, DEVCLR%)   'clear 4834 device
   TDELAY (1000)

   DO WHILE continue$ <> "N"
      DATAS = SPACE100S
      LOCATE 12, 1
      INPUT "Enter a test string to be sent to 4834 "; OUTPUT$
      CALL ABSOLUTE(ADDR%, OUTPUT$, IOOUTPUT%) 'OUTPUT THE STRING TO 4834
      CALL ABSOLUTE(IOERR%, IOCOUNT%, ERRPTR%)

'***************************************************************************
'WAIT UNTIL INTERRUPT BE SERVICED, AND ISRDONE% BECOME 1
'***************************************************************************

     WHILE ISRDONE% = 0
     WEND
'***************************************************************************
'DISPLAY VARIABLES AFTER INTERRUPT BE SERVICED
'***************************************************************************
    ISRDONE% = 0
    LOCATE 16, 1: PRINT "Current interrupt count is: "; INTCOUNT%
    LOCATE 17, 1: PRINT "Serial poll response right before ieenter is "; SR%
    LOCATE 18, 1: PRINT "The data read from 4834 by interupt routine is : ";
    LOCATE 19, 1
    IF SMR% = 1 THEN
        PRINT DATAS
    ELSE
        PRINT "4834 talk data not received  "
    END IF

    LOCATE 23, 1: INPUT "Continue the loop back test? y/n "; continue$
    continue$ = UCASE$(continue$)
    IF continue$ = "Y" THEN
        FOR I% = 11 TO 23
          LOCATE I, 1
          PRINT SPACE80S
        NEXT I%
    END IF
 LOOP
 CALL RESTOREVECTOR(IRQ%)      'restore the original interrupt vector
 END

